package hay.app;

import java.util.ArrayList;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

public class HaySetting extends Activity {

	private ArrayList<Date> anni_List;

	private Date birthday;
	private int lunar = 0;
	private LinearLayout anni_layout;

	private Button button_birthday;
	private Button button_anniversary;
	private Button button_save;
	private Button button_cancel;

	private RadioGroup check_receive;
	private RadioGroup check_3g;

	private EditText number_phone;
	private EditText number_front;
	private EditText number_back;
	private EditText edittext_twitter;
	private EditText edittext_me2day;
	private EditText edittext_name;
	private EditText edittext_email;

	private boolean first;
	
	private static final int SaveProgress=1;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.setting);

		//óΰ?
		Bundle bundle = this.getIntent().getExtras();
		first = bundle.getBoolean("first");
		button_save = (Button)findViewById(R.setting.button_save);
		button_cancel = (Button)findViewById(R.setting.button_cancel);
		check_receive = (RadioGroup)findViewById(R.setting.RadioGroup);
		check_3g = (RadioGroup)findViewById(R.setting.RadioGroup2);
		number_front = (EditText)findViewById(R.setting.number_front);
		number_back = (EditText)findViewById(R.setting.number_back);
		number_phone = (EditText)findViewById(R.setting.number_phone);
		button_birthday = (Button)findViewById(R.setting.button_birthday_add);
		button_anniversary = (Button)findViewById(R.setting.button_anniversary_add);
		anni_layout = (LinearLayout)findViewById(R.setting.anni_layout);
		edittext_twitter = (EditText)findViewById(R.setting.EditText_Twitter);
		edittext_me2day = (EditText)findViewById(R.setting.EditText_Me2day);
		edittext_name = (EditText)findViewById(R.setting.EditText_Myname);
		edittext_email = (EditText)findViewById(R.setting.EditText_Email);

		anni_List = new ArrayList<Date>();
		button_birthday.setText("");
		
		//ó̶
		if(first == true){

			//ĵư
			button_cancel.setVisibility(Button.GONE);
			
			AlertDialog.Builder ab = new AlertDialog.Builder(this);
			ab.setTitle("ݵ ");
			ab.setMessage("HAY twitter,me2day 3G    ߰ Ϳ ߻  ֽϴ. ù ȭ鿡 3G    ݵ ֽʽÿ.");
			ab.setIcon(R.drawable.icon);
			ab.setNegativeButton("Ȯ", 					
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {;
				}});
			ab.create().show();
		}
		else{

			SharedPreferences pref = getSharedPreferences("prefa",0);
			boolean op =pref.getBoolean("save_option_receive",false);
			boolean op2 =pref.getBoolean("save_option_3g",true);
			//radio
			if(op)
				check_receive.check(R.setting.radio1);
			else
				check_receive.check(R.setting.radio2);
			if(op2)	
				check_3g.check(R.setting.radio3);
			else
				check_3g.check(R.setting.radio4);

			init();

			/*
			String email =pref.getString("email", "");
			String twitter =pref.getString("twitter", "");
			String me2day =pref.getString("me2day", "");
			String myname =pref.getString("myname", "");
			String one =pref.getString("one", "");
			String two =pref.getString("two", "");
			String three =pref.getString("three", "");
			String birth =pref.getString("birth", "");
			int lunar =pref.getInt("lunar", 0);

			edit2.putInt("anycount", anni_List.size());

			for(int i=0;i<anni_List.size();i++){
				edit2.putString("anyname"+i,anni_List.get(i).getName());
				edit2.putString("anyday"+i,anni_List.get(i).getYear()+anni_List.get(i).getMonth()+anni_List.get(i).getDay()+"");					
			}
			 */
		}

		button_save.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {
						if( !edittext_name.getText().toString().equals("") && 
								!number_phone.getText().toString().equals("") && 
								!number_front.getText().toString().equals("") && 
								!number_back.getText().toString().equals("") ){

							save();
						}
						else Toast.makeText(HaySetting.this, "ʼ   Էּ", 1).show();
					}
				}
		);

		button_birthday.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {

						LayoutInflater factory = LayoutInflater.from(HaySetting.this);
						final View datepickerView = factory.inflate(R.layout.datepicker_birthday, null);

						new AlertDialog.Builder(HaySetting.this)
						.setIcon(R.drawable.icon)
						.setTitle(" ¥ ")
						.setView(datepickerView)
						.setCancelable(false)
						.setPositiveButton("", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {

								//¥ ͼ Ƶд.
								DatePicker dp = (DatePicker)datepickerView.findViewById(R.datepicker_birthday.DatePicker);
								CheckBox cb = (CheckBox)datepickerView.findViewById(R.datepicker_birthday.CheckBox);

								Date date = new Date();
								date.setYear( ""+dp.getYear() );
								if( dp.getMonth()+1 < 10 ) date.setMonth( "0"+(dp.getMonth()+1) );
								else date.setMonth( ""+(dp.getMonth()+1) );
								if( dp.getDayOfMonth() < 10 ) date.setDay( "0"+dp.getDayOfMonth() );
								else date.setDay( ""+dp.getDayOfMonth() );

								if(cb.isChecked()) lunar = 1;
								else lunar = 0;

								birthday = date;
								button_birthday.setText( ((lunar==1)?" ":" ")+date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
							}
						})
						.setNegativeButton("", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {
								button_birthday.setText("");
							}
						})
						.create().show();
					}
				}
		);

		button_anniversary.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {
						LayoutInflater factory = LayoutInflater.from(HaySetting.this);
						final View datepickerView = factory.inflate(R.layout.datepicker_setting, null);

						new AlertDialog.Builder(HaySetting.this)
						.setIcon(R.drawable.icon)
						.setTitle(" ¥ ")
						.setView(datepickerView)
						.setCancelable(false)
						.setPositiveButton("߰", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {

								//¥ ͼ Ƶд.
								DatePicker dp = (DatePicker)datepickerView.findViewById(R.datepicker_setting.DatePicker);
								EditText et = (EditText)datepickerView.findViewById(R.datepicker_setting.EditText);

								if(et.getText().toString().equals("")){
									Toast.makeText(HaySetting.this, "̸ Էʾ ҵǾϴ.", 0).show();
								}
								else{
									Date date = new Date();
									date.setYear( ""+dp.getYear() );
									if( dp.getMonth()+1 < 10 ) date.setMonth( "0"+(dp.getMonth()+1) );
									else date.setMonth( ""+(dp.getMonth()+1) );
									if( dp.getDayOfMonth() < 10 ) date.setDay( "0"+dp.getDayOfMonth() );
									else date.setDay( ""+dp.getDayOfMonth() );

									date.setName(et.getText().toString());

									TextView text = new TextView(HaySetting.this);
									text.setId(anni_List.size());
									text.setText( "+"+date.getName()+"     "+ date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
									text.setTextColor(Color.BLACK);
									text.setTextSize(14);
									text.setPadding(10,5,0,5);
									text.setOnClickListener(
											new View.OnClickListener() {
												public void onClick(final View v) {
													new AlertDialog.Builder(HaySetting.this)
													.setTitle("Ͻðڽϱ?")
													.setMessage(((TextView)v).getText())
													.setIcon(R.drawable.icon)
													.setPositiveButton("",
															new DialogInterface.OnClickListener() {
														public void onClick(DialogInterface dialog, int which) {
															anni_layout.removeViewAt(v.getId());
															anni_List.remove(v.getId());
														}
													})
													.setNegativeButton("ƴϿ", null).show();
												}
											}
									);
									anni_layout.addView(text);
									anni_List.add(date);
									Toast.makeText(HaySetting.this, "Ʒ ߰Ǿϴ.\nġϽø Ͻ  ֽϴ.", 1).show();
								}
							}
						})
						.setNegativeButton("", new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int whichButton) {
							}
						})
						.create().show();
					}
				}

		);

		button_cancel.setOnClickListener(
				new View.OnClickListener() {
					public void onClick(View v) {
						finish();
					}
				}
		);
	}

	private void init(){
		String db_twitter="";
		String db_me2day="";
		String db_birthday="";
		String myname="";
		String one="";
		String two="";
		String three="";
		String email="";
		int lunar;
		SharedPreferences pref = getSharedPreferences("prefa",0);
		SharedPreferences pref2 = getSharedPreferences("anni",0);

		myname = pref.getString("myname", "");
		one = pref.getString("one", "");
		two = pref.getString("two", "");
		three = pref.getString("three", "");
		email = pref.getString("email", "");
		lunar = pref.getInt("lunar", 0);
		db_birthday = pref.getString("birth", "");
		db_twitter = pref.getString("twitter","");
		db_me2day =pref.getString("me2day", "");

		edittext_name.setText(myname);
		number_phone.setText(one);
		number_front.setText(two);
		number_back.setText(three);
		edittext_email.setText(email);
		edittext_twitter.setText(db_twitter);
		edittext_me2day.setText(db_me2day);

		if( db_birthday == null){
			button_birthday.setText("");
		}
		else if(db_birthday.equals("")){
			button_birthday.setText("");
		}
		else{
			birthday = new Date();
			birthday.setYear(db_birthday.substring(0, 4));
			birthday.setMonth(db_birthday.substring(4, 6));
			birthday.setDay(db_birthday.substring(6, 8));

			button_birthday.setText( ((lunar==1)?" ":" ")+birthday.getYear()+" "+birthday.getMonth()+" "+birthday.getDay()+"");
		}



		//
		Log.d("qqq",Integer.toString(pref2.getInt("anycount",0)));
		for(int i=0; i<pref2.getInt("anycount",0);i++){
			String anny_name=pref2.getString("anyname"+i, "");
			String anny_day=pref2.getString("anyday"+i, "");

			Date date = new Date();
			date.setName(anny_name);
			date.setYear( anny_day.subSequence(0, 4).toString() );
			date.setMonth(anny_day.subSequence(4, 6).toString() );
			date.setDay( anny_day.subSequence(6, 8).toString() );
			TextView text = new TextView(this);
			text.setId(anni_List.size());
			text.setText( "["+date.getName()+"]     "+ date.getYear()+" "+date.getMonth()+" "+date.getDay()+"");
			text.setTextColor(Color.BLACK);
			text.setTextSize(12);
			text.setPadding(10,5,0,5);


			text.setOnClickListener(
					new View.OnClickListener() {
						public void onClick(final View v) {
							new AlertDialog.Builder(HaySetting.this)
							.setTitle("Ͻðڽϱ?")
							.setMessage(((TextView)v).getText())
							.setIcon(R.drawable.icon)
							.setPositiveButton("",
									new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {
									anni_layout.removeViewAt(v.getId());
									anni_List.remove(v.getId());
								}
							})
							.setNegativeButton("ƴϿ", null).show();
						}
					}
			);

			anni_layout.addView(text);
			anni_List.add(date);
		}


	}

	private void save(){

		showDialog(SaveProgress);
		
		new Thread(
				new Runnable() {			
			public void run() {
				//
				boolean receive=true;
				boolean receive2=true;
				switch(check_receive.getCheckedRadioButtonId()){
				case R.setting.radio1:
					receive = true;
					break;
				case R.setting.radio2:
					receive = false;
					break;
				}
				switch(check_3g.getCheckedRadioButtonId()){
				case R.setting.radio3:
					receive2 = true;
					break;
				case R.setting.radio4:
					receive2 = false;
					break;
				}

				SharedPreferences pref = getSharedPreferences("prefa",0);
				SharedPreferences.Editor edit = pref.edit();
				edit.putBoolean("save_option_receive", receive);
				edit.putBoolean("save_option_3g", receive2);
				SharedPreferences pref2 = getSharedPreferences("anni",0);
				SharedPreferences.Editor edit2 = pref2.edit();

				//ó̹Ƿ Ѵ.
				String date;
				if( button_birthday.getText().toString().equals("")) date="";
				else date = ""+birthday.getYear()+birthday.getMonth()+birthday.getDay();

				String email = edittext_email.getText().toString();
				String twitter = edittext_twitter.getText().toString();
				String me2day = edittext_me2day.getText().toString();

				String myname = edittext_name.getText().toString();
				String one = number_phone.getText().toString();
				String two = number_front.getText().toString();
				String three = number_back.getText().toString();
				edit.putString("email",email);
				edit.putString("twitter",twitter);
				edit.putString("me2day", me2day);
				edit.putString("myname", myname);
				edit.putString("one", one);
				edit.putString("two", two);
				edit.putString("three", three);
				edit.putString("birth", date);
				edit.putInt("lunar",lunar);

				edit2.putInt("anycount", anni_List.size());

				for(int i=0;i<anni_List.size();i++){
					edit2.putString("anyname"+i,anni_List.get(i).getName());
					edit2.putString("anyday"+i,anni_List.get(i).getYear()+anni_List.get(i).getMonth()+anni_List.get(i).getDay()+"");					
				}

				edit.commit();
				edit2.commit();
				finish();
			}
		}).start();
	}

	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if(keyCode==4){
			AlertDialog.Builder ab = new AlertDialog.Builder(this);
			ab.setTitle("Ͻðڽϱ?");
			ab.setIcon(R.drawable.icon);
			ab.setPositiveButton("",
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					if( !edittext_name.getText().toString().equals("") && 
							!number_phone.getText().toString().equals("") && 
							!number_front.getText().toString().equals("") && 
							!number_back.getText().toString().equals("") ){

						save();
					}
					else Toast.makeText(HaySetting.this, "ʼ   Էּ", 1).show();
				}});
			ab.setNegativeButton("ڷΰ", 					
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					if(first==true){
						Toast.makeText(HaySetting.this, "ó̹Ƿ  Էּ.", 1).show();
					}
					else{
						finish();
					}
				}});
			ab.create().show();
		}
		return false;
	}

	private ProgressDialog mProgressDialog;
	protected Dialog onCreateDialog(int id) {
		switch(id){
			case SaveProgress:
				mProgressDialog = new ProgressDialog(HaySetting.this);
				//mProgressDialog.setIcon(R.drawable.alert_dialog_icon);
				mProgressDialog.setMessage(" ... ");
				mProgressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
				mProgressDialog.setCancelable(false);
				break;
		}
		return mProgressDialog;
	}

	private class Date {

		private String name;
		private String year;
		private String month;
		private String day;

		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public String getYear() {
			return year;
		}
		public void setYear(String year) {
			this.year = year;
		}
		public String getMonth() {
			return month;
		}
		public void setMonth(String month) {
			this.month = month;
		}
		public String getDay() {
			return day;
		}
		public void setDay(String day) {
			this.day = day;
		}
	}
}
