package hay.component;

import android.content.ContentResolver;
import android.database.Cursor;
import android.net.Uri;
import android.provider.ContactsContract;
import android.provider.ContactsContract.PhoneLookup;

public class HayLookup {
	String name=null;
	int contact_id=-1;
	ContentResolver cr;
	
	public HayLookup(ContentResolver cr) {
		this.cr = cr;
	}
	
	/**
	 * ش ȣ Contact ˻ϰ   Ѵ. getName, getContact_id()
	 * @param number ȭȣ
	 * @return contact ش ȣ ִٸ true, ٸ  false
	 */
	public boolean open(String number){
		Uri uri = Uri.withAppendedPath(ContactsContract.PhoneLookup.CONTENT_FILTER_URI, Uri.encode(number));		
		Cursor c = cr.query(uri,new String[] {PhoneLookup.DISPLAY_NAME,PhoneLookup._ID }, null, null,null);

		if(c!=null){
			if (c.moveToNext()) {
				name = c.getString(c.getColumnIndexOrThrow(PhoneLookup.DISPLAY_NAME));
				contact_id = c.getInt(c.getColumnIndexOrThrow(PhoneLookup._ID));
			}
			else{
				return false;
			}
			return true;
		}
		else{
			return false;
		}
	}
	
	public String getName() {
		return name;
	}
	public int getContact_id() {
		return contact_id;
	}
}
