package hay.tab;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.LongBuffer;
import java.util.ArrayList;
import java.util.Calendar;
import hay.app.HayDetail;
import hay.app.HaySmsDetail;
import hay.app.R;
import hay.component.HayChange;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.component.HayLookup;
import hay.database.HayDatabase;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.CallLog;
import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class ListCallLog extends ListActivity  {

	private ArrayList<Call_Log> cateList;

	private ListAdapter cAdapter;
	private HayDatabase mDbHelper  = new HayDatabase(this);

	private long lasttime;

	private boolean passOncreate;

	private String[] selectNumber;

	static public boolean isend = false;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.call_log_list);

		cateList = new ArrayList<Call_Log>();
		cAdapter = new ListAdapter(cateList);

		Thread thread = new Thread(doBackgroundcalculation);
		thread.start();

		Calendar cal = Calendar.getInstance();
		lasttime = cal.getTimeInMillis();
	}

	private Runnable doBackgroundcalculation = new Runnable()
	{
		public void run()
		{
			CallLogProcessing();
			SmsProcessing();

			mHandler.sendMessage(mHandler.obtainMessage(DOUpdate));

			calculationScore();

		}
	};

	protected void onPause() {
		super.onPause();

	}

	protected void onResume() {
		super.onResume();

		if(passOncreate == false){
			//࿡ onCreate ؼ ° ƴ϶ ֽ ȭ ſ ̰ ʿϴ.
			//Handler  2Ŀ ȭ鿡 ֽű ϰ ߴ.
			Handler handler = new Handler();
			handler.postDelayed(
					new Runnable() {
						public void run() {
							int location;
							boolean isadd;

							Cursor Call_cursor = getContentResolver().query(
									CallLog.Calls.CONTENT_URI,
									new String[]{CallLog.Calls.CACHED_NAME,CallLog.Calls.NUMBER,CallLog.Calls.DATE,CallLog.Calls.TYPE}, 
									null, null, null);
							Cursor Sms_cursor = getContentResolver().query(Uri.parse("content://sms/"),
									new String[]{"address","date","type"},
									null, null, null);

							startManagingCursor(Call_cursor);
							startManagingCursor(Sms_cursor);

							location = 0;
							isadd = false;

							//ݷα   Ʈ Ѵ.
							//ֽż Ϸ Ųٷ .
							if(Call_cursor.moveToLast()){
								do{
									//ֽſ ŵ ȭ ִ ð ͼ Ѵ.
									long longtypetime = Call_cursor.getLong(Call_cursor.getColumnIndexOrThrow("date"));

									if (longtypetime > lasttime) {

										Call_Log call_log = new Call_Log();
										String name = null;
										String number = null;
										long date = 0;
										int type;

										//   
										name = Call_cursor.getString(Call_cursor.getColumnIndexOrThrow(CallLog.Calls.CACHED_NAME));
										number = Call_cursor.getString(Call_cursor.getColumnIndexOrThrow(CallLog.Calls.NUMBER));
										date = Call_cursor.getLong(Call_cursor.getColumnIndexOrThrow(CallLog.Calls.DATE));
										type = Call_cursor.getInt(Call_cursor.getColumnIndexOrThrow(CallLog.Calls.TYPE));

										if(type<4){

											call_log.setName(name);
											call_log.setNumber(number);
											call_log.setString_time(HayChange.long2String(date));
											call_log.setLong_Time(date);
											call_log.setState(type);

											cateList.add(0,call_log);
										}
									}
									else break;
								}
								while(Call_cursor.moveToPrevious());
							}
							//ݷα  


							// ʱȭ Ű ̹
							// ڵ鿡  ֽű Ѵ.
							location = 0;
							isadd = false;
							while(Sms_cursor.moveToNext()){

								long longtypetime = Sms_cursor.getLong(Sms_cursor.getColumnIndexOrThrow("date"));

								//  ó ð Ŀ Ӱ  ȭ,ڵ  ó
								if (longtypetime > lasttime) {

									String number = null;
									number = Sms_cursor.getString(Sms_cursor.getColumnIndexOrThrow("address"));
									long date = Sms_cursor.getLong(Sms_cursor.getColumnIndexOrThrow("date"));
									int type = Sms_cursor.getInt(Sms_cursor.getColumnIndexOrThrow("type"));

									Call_Log call_log = new Call_Log();

									//   
									HayLookup lookup = new HayLookup(getContentResolver());
									//ȣ  
									if( number.equals("") == false ){
										// ̶ ִٸ
										if( lookup.open( number )){
											call_log.setName(lookup.getName());				
										}
										// ȵ ̶
										else{
											String str = number;
											int flag = str.indexOf(";");
											if (flag!=-1)
												str= str.substring(0,flag);
											call_log.setName(str);
										}
									}
									else{
										call_log.setName("");
									}

									call_log.setName("");
									call_log.setNumber(number);
									call_log.setString_time(HayChange.long2String(date));
									call_log.setLong_Time(date);
									if(type==1)
										call_log.setState(4);
									else
										call_log.setState(5);
									if (cateList.size() == 0) {
										cateList.add(location, call_log);
									} else {
										while (cateList.size() > location) { // Listũ⺸ ۴ٸ   ִ.

											//  call_log ð ִ ð 
											if (cateList.get(location).getLong_time() < date) {
												// °  ð̶ addѴ.
												cateList.add(location, call_log);
												isadd = true;
												break;
											}
											location++;
										}
										// ᱹ    ٸ  
										if (isadd == false) {
											cateList.add(call_log);
										} else
											isadd = false;
									}
								}
								else break;
							}

							cAdapter.notifyDataSetChanged();
							Calendar cal = Calendar.getInstance();

							// -1000 ϴ  ̾ 
							lasttime = cal.getTimeInMillis()-1000;

							//mDbHelper.close();
						}
					}, 1000);
		}
		else{
			passOncreate=false;
		}
	}


	private void CallLogProcessing() {

		Cursor cursor = getContentResolver().query(
				CallLog.Calls.CONTENT_URI,
				new String[]{CallLog.Calls.NUMBER,CallLog.Calls.DATE,CallLog.Calls.TYPE}, 
				null, null, null);
		
		// ֽ Ϻ ǥϱ   鼭 óѴ.
		if ( cursor.moveToLast()){
			int size = 70;
			do {
				if( size-- == 0) break;
				String number = null;
				long date = 0;
				int type;

				//int duration;

				//   
				number = cursor.getString(0);
				date = cursor.getLong(1);
				type = cursor.getInt(2);

				if(type<4){
					Call_Log call_log = new Call_Log();
					call_log.setNumber(number);
					call_log.setString_time(HayChange.long2String(date));
					call_log.setLong_Time(date);
					call_log.setState(type);

					cateList.add(call_log);
				}
				else{
					size++;
				}


			} while (cursor.moveToPrevious());
		}
		
		cursor.close();
	}

	private void SmsProcessing() {
		int location = 0;
		boolean isadd = false;

		Cursor cursor = getContentResolver().query(Uri.parse("content://sms/"),
				new String[]{"address","date","type"},
				null, null, null);
		
		if(cursor!=null){

			int size=70;

			// ڴ  ֽż Ƿ moveTonext ̿Ѵ.
			while (cursor.moveToNext()) {
				if(size--==0) break;

				//  
				String number = null;
				number = cursor.getString(0);
				long date = cursor.getLong(1);
				int type = cursor.getInt(2);

				Call_Log call_log = new Call_Log();

				call_log.setNumber(number);
				call_log.setString_time(HayChange.long2String(date));
				call_log.setLong_Time(date);
				if(type==1)
					call_log.setState(4);
				else
					call_log.setState(5);
				if (cateList.size() == 0) {
					cateList.add(location, call_log);
				} else {
					while (cateList.size() > location) { // Listũ⺸ ۴ٸ   ִ.

						//  call_log ð ִ ð 
						if (cateList.get(location).getLong_time() < date) {
							// °  ð̶ addѴ.
							cateList.add(location, call_log);
							isadd = true;
							break;
						}
						location++;
					}
					// ᱹ    ٸ  
					if (isadd == false) {
						cateList.add(call_log);
					} else
						isadd = false;
				}

			}
		}
		
		cursor.close();
	}

	private void calculationScore(){

		mDbHelper.open();

		long lastProcessTime = 0;

		//  óߴ Ͻø ҷ´.
		try {
			FileInputStream fos = openFileInput("lastTime.txt");
			byte[] data = new byte[8];
			fos.read(data);
			fos.close();
			ByteBuffer byte_buf = ByteBuffer.allocate(8);
			final byte[] change = new byte[8];

			for (int i = 0; i < 8; i++) {
				change[i] = (byte) 0x00;
			}
			for (int i = 0; i < data.length; i++) {
				change[7 - i] = data[data.length - 1 - i];
			}

			byte_buf = ByteBuffer.wrap(change);
			byte_buf.order(ByteOrder.BIG_ENDIAN);
			lastProcessTime = byte_buf.getLong();
		} catch (Exception e) {
			lastProcessTime = 0;
		}

		// ó ߴ ˻縦  
		//ð ,,ϸ  ð .
		Calendar now = Calendar.getInstance();
		now.set( now.get(Calendar.YEAR), now.get(Calendar.MONTH)+1, now.get(Calendar.DAY_OF_MONTH) );

		// ó ð ,,ϸ  ð .
		Calendar last = Calendar.getInstance();
		last.setTimeInMillis(lastProcessTime);
		last.set( last.get(Calendar.YEAR), last.get(Calendar.MONTH)+1, last.get(Calendar.DAY_OF_MONTH) );

		// ó  Ϸ簡 ? (Ϸ翡 ѹ óϱ) 
		int days = (int)(now.getTimeInMillis() - last.getTimeInMillis())/1000/60/60/24; 


		// ó ð Ϸ ̻  ٸ  (  ų ̴.)
		if(days > 0){
			// ִ   ´.
			Cursor cursor = mDbHelper.fetchAddtion();

			//ѳ  ų ̴.
			if(cursor != null){
				while(cursor.moveToNext()){

					//ش    ð ´.
					long lasttime = cursor.getLong(2);

					//  ð ,,ϸ  ð .
					Calendar save = Calendar.getInstance();
					save.setTimeInMillis(lasttime);
					save.set(save.get(Calendar.YEAR), save.get(Calendar.MONTH)+1, save.get(Calendar.DAY_OF_MONTH) );

					//  ðκ ̳  ߳?
					int day = (int)(now.getTimeInMillis() - save.getTimeInMillis())/1000/60/60/24;

					//Ϸ ̻  ߴٸ  ̴. day--
					//̹    쵵 Ѵ. count--
					int minus=0;
					int count = days;
					while( day > 0 && count > 0){
						minus += 5;
						day--;
						count--;
					}

					//  Ű Ѵ.
					if(minus > 0){
						int score = cursor.getInt(1) - minus; //  ̳ʽ Ŵ
						if( score < 1 ) score = 1;
						mDbHelper.updateScore(cursor.getInt(0), score); //
					}

				}
			}
			cursor.close();
		}

		//   
		//  ̴.
		//׷  ݷα׸ ܾͼ groupby Ű.
		ArrayList<cal_Info> Infos = new ArrayList<cal_Info>();

		// ݷα׿ ִ     
		for (int i = 0; i < cateList.size(); i++) {

			long calltime = cateList.get(i).getLong_time();

			//  ó ð Ŀ Ӱ  ͵鸸  ó
			if (calltime > lastProcessTime) {

				boolean find=false;
				for(int x=0; x < Infos.size() ; x++){ //Lookup contact Id    Overhead ũǷ ̱   ȣ  鼭 ó.

					if( Infos.get(x).getNumber().equals(cateList.get(i).getNumber())){	
						find=true;
						// 
						switch (cateList.get(i).getState()) {
						case 1: // ȭ
							Infos.get(x).setScore(Infos.get(x).getScore()+10);
							break;
						case 2: // ȭ߽
							Infos.get(x).setScore(Infos.get(x).getScore()+10);
							break;
						case 3: // ߼
							Infos.get(x).setScore(Infos.get(x).getScore()+5);
							break;
						case 4: // ڼ
							Infos.get(x).setScore(Infos.get(x).getScore()+2);
							break;
						case 5: // ڹ߽
							Infos.get(x).setScore(Infos.get(x).getScore()+2);
							break;
						}
						Infos.get(x).setCount(Infos.get(x).getCount()+1);
						Infos.get(x).setLastTime(cateList.get(i).getLong_time());
					}
				}
				if(find == false){

					cal_Info info = new cal_Info();
					//̸
					info.setNumber(cateList.get(i).getNumber());
					//
					switch (cateList.get(i).getState()) {
					case 1: // ȭ
						info.setScore(10);
						break;
					case 2: // ȭ߽
						info.setScore(10);
						break;
					case 3: // ߼
						info.setScore(5);
						break;
					case 4: // ڼ
						info.setScore(2);
						break;
					case 5: // ڹ߽
						info.setScore(2);
						break;
					}
					//¼
					info.setCount(1);
					//½ð
					info.setLastTime(cateList.get(i).getLong_time());

					Infos.add(info);
				}	
			}
			// óð ~
			else break;
		}

		//       ̽ .
		for(int i=0;i < Infos.size();i++){

			HayLookup lookup = new HayLookup(getContentResolver());

			//ȭο ?
			if( Infos.get(i).getNumber().equals("") == false ){
				if(lookup.open(Infos.get(i).getNumber())){ 

					int contact_id = lookup.getContact_id();

					//ֳ ִ  óѴ.
					int thisscore = mDbHelper.fetchScore(contact_id);

					if(thisscore == -1){
						// °̹Ƿ ߰ 
						mDbHelper.insertAddtion(contact_id);
						thisscore = 100;
					}

					thisscore += Infos.get(i).getScore();
					if(thisscore > 500) thisscore = 500;	
					mDbHelper.fetchScore(contact_id);
					mDbHelper.updateScore(contact_id, thisscore);
					mDbHelper.updateLastTime(contact_id, Infos.get(i).getLastTime());
					mDbHelper.updateIncrementContactNumber(contact_id, Infos.get(i).getCount());
				}
			}
		}

		mDbHelper.close();

		//  óߴ ð Ѵ..
		try {
			Calendar calendar = Calendar.getInstance();

			byte[] bArray = new byte[8];
			ByteBuffer bBuffer = ByteBuffer.wrap(bArray);
			LongBuffer lBuffer = bBuffer.asLongBuffer();
			lBuffer.put(0, calendar.getTimeInMillis());

			FileOutputStream fos = openFileOutput("lastTime.txt",Context.MODE_WORLD_WRITEABLE);
			fos.write(bArray);
			fos.close();
		} catch (Exception e) {

		}
	}

	int contact_id;
	protected void onListItemClick(ListView l, View v, final int position,long id) {
		super.onListItemClick(l, v, position, id);
		ArrayList<String> phoneNumber = new ArrayList<String>();
		String[] selectString;

		contact_id = -1;

		if(cateList.get(position).getNumber().equals("") == false){

			HayLookup lookup = new HayLookup(getContentResolver());

			//ּҷϿ    ȭȣ  ´.
			if( lookup.open(cateList.get(position).getNumber()) ){
				contact_id = lookup.getContact_id();
				HayContactAdapter contactAdapter = new HayContactAdapter(getContentResolver());
				HayContact contact = contactAdapter.getContact(contact_id);

				selectString = new String[] { "Call", "SMS", " " };
				if(contact.isHasPhone()){
					for(int i =0 ; i < contact.getPhone_type().size() ; i++){
						phoneNumber.add(contact.getPhone_number().get(i));                  
					}
					// ȣ Ƶд.
					selectNumber = new String[phoneNumber.size()];
					for(int i=0;i<phoneNumber.size();i++){
						selectNumber[i] = phoneNumber.get(i);
					}
				}
			}
			//ּҷϿ    ش  ȭȣ Ѵ.
			else{
				selectString = new String[] { "Call", "SMS", "ּҷ߰ " };
				selectNumber = new String[1];
				selectNumber[0] = cateList.get(position).getNumber();
			}


			//,ȭ,󼼺 ,
			new AlertDialog.Builder(this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectString,
					new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int what) {
					switch (what) {
					case 0:// ȭκ

						if(selectNumber.length>1){
							//ȭȣ 
							new AlertDialog.Builder(ListCallLog.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
									new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {
									Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[which]));
									startActivity(i);
								}
							}).setNegativeButton("", null).show();
						}else{
							//ٷ ȭ
							Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[0]));
							startActivity(i);
						}
						break;

					case 1: // ںκ
						if(selectNumber.length>1){
							//ȭȣ
							new AlertDialog.Builder(ListCallLog.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
									new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {
									Intent i2 = new Intent(ListCallLog.this,HaySmsDetail.class);
									i2.putExtra("contact_number",selectNumber[which]);
									startActivity(i2);
								}
							}).setNegativeButton("", null).show();
						}else{
							//ٷ ȭ
							Intent i2 = new Intent(ListCallLog.this,HaySmsDetail.class);
							i2.putExtra("contact_number",selectNumber[0]);
							startActivity(i2);
						}
						break;

					case 2: // 
						if(contact_id == -1){
							AlertDialog.Builder alert = new AlertDialog.Builder(ListCallLog.this);
							alert.setIcon(R.drawable.icon);
							alert.setTitle(cateList.get(position).getName()+" ߰Ͻðڽϱ?");
							alert.setPositiveButton("Ȯ", 
									new DialogInterface.OnClickListener() {
								public void onClick(DialogInterface dialog, int which) {
									// ּҷ  θ. 
									Intent intent = new Intent(Intent.ACTION_INSERT,ContactsContract.Contacts.CONTENT_URI); 
									intent.putExtra("phone", cateList.get(position).getName()); 
									startActivity(Intent.createChooser(intent, "Select Contact"));
								}
							});
							alert.setNegativeButton("", null	);
							AlertDialog ad = alert.create();
							ad.show();
						}
						else{
							Intent intent = new Intent(ListCallLog.this, HayDetail.class);
							intent.putExtra("contact_id", contact_id);
							startActivity(intent);
						}

						break;
					}
				}
			}).setNegativeButton("", null).show();
		}
	}

	private class ListAdapter extends ArrayAdapter<Call_Log> {

		private ArrayList<Call_Log> items;

		public ListAdapter(ArrayList<Call_Log> items) {
			super(ListCallLog.this, 0, items);
			this.items = items;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;
			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.list_calllog, null);
			}

			TextView name = (TextView) v.findViewById(R.list_content.name);
			TextView number = (TextView) v.findViewById(R.list_content.number);
			TextView time = (TextView) v.findViewById(R.list_content.time);
			ImageView state = (ImageView) v.findViewById(R.list_content.state);

			if(items.get(position).getName()==null){

				if( items.get(position).getNumber().equals("") == false ){

					// ̶ ִٸ
					HayLookup lookup = new HayLookup(getContentResolver());
					if( lookup.open( items.get(position).getNumber() )){
						items.get(position).setName(lookup.getName());
					}
					// ȵ ̶
					else{
						String str = items.get(position).getNumber();
						int flag = str.indexOf(";");
						if (flag!=-1)
							str= str.substring(0,flag);
						items.get(position).setName(str);
					}

				}
				else{
					items.get(position).setName(" ");
				}
			} 

			name.setText(""+items.get(position).getName());
			number.setText(""+items.get(position).getNumber());
			time.setText(""+items.get(position).getString_time());


			int selectImg = items.get(position).getState();
			switch (selectImg) {
			case 1: // ȭ
				state.setImageResource(R.drawable.callin);
				break;
			case 2: // ȭ߽
				state.setImageResource(R.drawable.callsend);
				break;
			case 3: // ߼
				state.setImageResource(R.drawable.callno);
				break;
			case 4: // ڼ
				state.setImageResource(R.drawable.sms_in);
				break;
			case 5: // ڹ߽
				state.setImageResource(R.drawable.sms_send);
				break;
			}

			return v;
		}
	}

	private final int DOUpdate = 1;
	private Handler mHandler = new Handler() {

		public void handleMessage(Message msg) {

			switch (msg.what){
			//Ʈ ȭ
			case DOUpdate:
				setListAdapter(cAdapter);
				break;	
			default:
				super.handleMessage(msg);
			}
		}
	};

	private class Call_Log {
		private String name; // ̸
		private String number; // ȭȣ
		private String string_time; // ð String type
		private long long_time; // ð long type
		private int state;

		public int getState() {
			return state;
		}
		public void setState(int state) {
			this.state = state;
		}

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public String getNumber() {
			return number;
		}

		public void setNumber(String number) {
			this.number = number;
		}

		public String getString_time() {
			return string_time;
		}

		public void setString_time(String stringTime) {
			string_time = stringTime;
		}

		public long getLong_time() {
			return long_time;
		}

		public void setLong_Time(long longTime) {
			long_time = longTime;
		}
	}

	private class cal_Info{
		long lastTime;
		int count;
		int score;
		String number;
		public long getLastTime() {
			return lastTime;
		}
		public void setLastTime(long lastTime) {
			this.lastTime = lastTime;
		}
		public int getCount() {
			return count;
		}
		public void setCount(int count) {
			this.count = count;
		}
		public int getScore() {
			return score;
		}
		public void setScore(int score) {
			this.score = score;
		}
		public String getNumber() {
			return number;
		}
		public void setNumber(String number) {
			this.number = number;
		}
	}
}
